/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-31 18:26
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 5000;
const ll MOD = 998244353;

ll binpow(ll a, ll n, ll m = MOD){
  ll res = 1;
  for(ll i = 1; i <= n; i <<= 1){
    if(i & n) res = res * a % m;
    a = a * a % m;
  }
  return res;
}

ll comb[MAXN][MAXN];
void comb_precalc(int N){
  comb[0][0] = 1;
  for(int n = 1; n <= N; n++)
    for(int k = (n + 1) / 2; k <= n; k++)
      comb[k][n] = comb[n - k][n] =
        comb[k - 1][n - 1] + comb[k][n - 1] % MOD;
}


vector<ll> f(MAXN);


ll N, K, res;


void solve(){
    // Code goes here ...
    cin >> N >> K;
    res = 0;

    // precalc factorials
    f[0] = f[1] = 1;
    F(i, 1, K + 3)
        f[i] = f[i-1] * i % MOD;
    comb_precalc(N);

    int p = 1, x;
    while((x = N - p * K) >= 0){
        cerr << binpow(K, x) << endl;
        cerr << comb[x + 1][p + x + 1] << endl;
        res += binpow(f[K], p) * binpow(K, x) % MOD * comb[x + 1][p + x + 1] % MOD;
        p++;
    }

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
